diff -Naur a/commands-nas.c b/commands-nas.c
--- a/commands-nas.c	2019-10-23 17:14:22.415080522 -0700
+++ b/commands-nas.c	2019-10-23 17:27:28.512157479 -0700
@@ -369,3 +369,133 @@
 	qmi_set_nas_network_scan_request(msg, &sreq);
 	return QMI_CMD_REQUEST;
 }
+
+
+static void
+cmd_nas_get_cell_location_info_cb(struct qmi_dev *qmi, struct qmi_request *req, struct qmi_msg *msg)
+{
+	struct qmi_nas_get_cell_location_info_response res;
+	void *c, *info;
+
+	if (! qmi_parse_nas_get_cell_location_info_response(msg, &res)) {
+		c = blobmsg_open_table(&status, NULL);
+
+		if (res.set.geran_info) {
+			blobmsg_add_string(&status, "type", "geran");
+			blobmsg_add_u32(&status, "cell id", (int32_t) res.data.geran_info.cell_id);
+		}
+
+		if (res.set.umts_info) {
+			blobmsg_add_string(&status, "type", "umts");
+			blobmsg_add_u32(&status, "cell id", (int32_t) res.data.umts_info.cell_id);
+		}
+
+		if (res.set.cdma_info) {
+			blobmsg_add_string(&status, "type", "cdma");
+			blobmsg_add_u32(&status, "base station id", (int32_t) res.data.cdma_info.base_station_id);
+		}
+
+		if (res.set.intrafrequency_lte_info) {
+			blobmsg_add_string(&status, "type", "intrafrequency lte");
+			blobmsg_add_u32(&status, "ue in idle", (int32_t) res.data.intrafrequency_lte_info.ue_in_idle);
+			blobmsg_add_string(&status, "plmn", res.data.intrafrequency_lte_info.plmn);
+			blobmsg_add_u32(&status, "tracking area code", (int32_t) res.data.intrafrequency_lte_info.tracking_area_code);
+			blobmsg_add_u32(&status, "global cell id", (int32_t) res.data.intrafrequency_lte_info.global_cell_id);
+			blobmsg_add_u32(&status, "eutra absolute rf channel number", (int32_t) res.data.intrafrequency_lte_info.eutra_absolute_rf_channel_number);
+			blobmsg_add_u32(&status, "serving cell id", (int32_t) res.data.intrafrequency_lte_info.serving_cell_id);
+			blobmsg_add_u32(&status, "cell reselection priority", (int32_t) res.data.intrafrequency_lte_info.cell_reselection_priority);
+			blobmsg_add_u32(&status, "s non intra search threshold", (int32_t) res.data.intrafrequency_lte_info.s_non_intra_search_threshold);
+			blobmsg_add_u32(&status, "serving cell low threshold", (int32_t) res.data.intrafrequency_lte_info.serving_cell_low_threshold);
+			blobmsg_add_u32(&status, "s intra search threshold", (int32_t) res.data.intrafrequency_lte_info.s_intra_search_threshold);
+			for (int i = 0; i < res.data.intrafrequency_lte_info.cell_n; i++) {
+				info = blobmsg_open_table(&status, NULL);
+				blobmsg_add_u32(&status, "physical cell id", (int32_t) res.data.intrafrequency_lte_info.cell[i].physical_cell_id);
+				blobmsg_add_u32(&status, "rsrq", (int32_t) res.data.intrafrequency_lte_info.cell[i].rsrq);
+				blobmsg_add_u32(&status, "rsrp", (int32_t) res.data.intrafrequency_lte_info.cell[i].rsrp);
+				blobmsg_add_u32(&status, "rssi", (int32_t) res.data.intrafrequency_lte_info.cell[i].rssi);
+				blobmsg_add_u32(&status, "cell selection rx level", (int32_t) res.data.intrafrequency_lte_info.cell[i].cell_selection_rx_level);
+				blobmsg_close_table(&status, info);
+			}
+		}
+
+		blobmsg_close_table(&status, c);
+	}
+}
+
+static enum qmi_cmd_result
+cmd_nas_get_cell_location_info_prepare(struct qmi_dev *qmi, struct qmi_request *req, struct qmi_msg *msg, char *arg)
+{
+	qmi_set_nas_get_cell_location_info_request(msg);
+	return QMI_CMD_REQUEST;
+}
+
+static void
+cmd_nas_get_tx_rx_info_cb(struct qmi_dev *qmi, struct qmi_request *req, struct qmi_msg *msg)
+{
+	struct qmi_nas_get_tx_rx_info_response res;
+	void *c;
+
+	if (! qmi_parse_nas_get_tx_rx_info_response(msg, &res)) {
+		c = blobmsg_open_table(&status, NULL);
+
+		if (res.set.rx_chain_0_info) {
+			blobmsg_add_u32(&status, "is_radio_tuned", (bool) res.data.rx_chain_0_info.is_radio_tuned);
+			blobmsg_add_u32(&status, "rx_power", (int32_t) res.data.rx_chain_0_info.rx_power);
+			blobmsg_add_u32(&status, "ecio", (int32_t) res.data.rx_chain_0_info.ecio);
+			blobmsg_add_u32(&status, "rscp", (int32_t) res.data.rx_chain_0_info.rscp);
+			blobmsg_add_u32(&status, "rsrp", (int32_t) res.data.rx_chain_0_info.rsrp);
+			blobmsg_add_u32(&status, "phase", (uint32_t) res.data.rx_chain_0_info.phase);
+		}
+
+		if (res.set.rx_chain_1_info) {
+			blobmsg_add_u32(&status, "is_radio_tuned", (bool) res.data.rx_chain_1_info.is_radio_tuned);
+			blobmsg_add_u32(&status, "rx_power", (int32_t) res.data.rx_chain_1_info.rx_power);
+			blobmsg_add_u32(&status, "ecio", (int32_t) res.data.rx_chain_1_info.ecio);
+			blobmsg_add_u32(&status, "rscp", (int32_t) res.data.rx_chain_1_info.rscp);
+			blobmsg_add_u32(&status, "rsrp", (int32_t) res.data.rx_chain_1_info.rsrp);
+			blobmsg_add_u32(&status, "phase", (uint32_t) res.data.rx_chain_1_info.phase);
+		}
+
+		if (res.set.tx_info) {
+			blobmsg_add_u32(&status, "is_in_traffic", (bool) res.data.tx_info.is_in_traffic);
+			blobmsg_add_u32(&status, "tx_power", (int32_t) res.data.tx_info.tx_power);
+		}
+
+		if (res.data.lte_uplink_modulation_n > 0) {
+			for (int i = 0; i < res.data.lte_uplink_modulation_n; i++) {
+				switch (res.data.lte_uplink_modulation[i]) {
+					case 0:
+						blobmsg_add_string(&status, "tx_modulation", "BPSK");
+						break;
+					case 1:
+						blobmsg_add_string(&status, "tx_modulation", "QPSK");
+						break;
+					case 2:
+						blobmsg_add_string(&status, "tx_modulation", "16-QAM");
+						break;
+					case 3:
+						blobmsg_add_string(&status, "tx_modulation", "64-QAM");
+						break;
+					default:
+						blobmsg_add_u32(&status, "tx_modulation", res.data.lte_uplink_modulation[i]);
+						break;
+				}
+			}
+		} else {
+			printf("No uplink modulation parameters\n");
+		}
+
+		blobmsg_close_table(&status, c);
+	}
+}
+
+static enum qmi_cmd_result
+cmd_nas_get_tx_rx_info_prepare(struct qmi_dev *qmi, struct qmi_request *req, struct qmi_msg *msg, char *arg)
+{
+	struct qmi_nas_get_tx_rx_info_request sreq;
+	sreq.set.radio_interface = 1;
+	sreq.data.radio_interface = QMI_NAS_RADIO_INTERFACE_LTE;
+
+	qmi_set_nas_get_tx_rx_info_request(msg, &sreq);
+	return QMI_CMD_REQUEST;
+}
diff -Naur a/commands-nas.h b/commands-nas.h
--- a/commands-nas.h	2019-10-23 17:14:08.199530945 -0700
+++ b/commands-nas.h	2019-10-23 17:27:26.120228573 -0700
@@ -29,6 +29,8 @@
 	__uqmi_command(nas_network_scan, network-scan, no, QMI_SERVICE_NAS), \
 	__uqmi_command(nas_get_signal_info, get-signal-info, no, QMI_SERVICE_NAS), \
 	__uqmi_command(nas_get_serving_system, get-serving-system, no, QMI_SERVICE_NAS), \
+	__uqmi_command(nas_get_cell_location_info, get-cell-location-info, no, QMI_SERVICE_NAS), \
+	__uqmi_command(nas_get_tx_rx_info, get-tx-rx-info, no, QMI_SERVICE_NAS), \
 	__uqmi_command(nas_set_network_preference, set-network-preference, required, CMD_TYPE_OPTION), \
 	__uqmi_command(nas_set_roaming, set-network-roaming, required, CMD_TYPE_OPTION) \
 
@@ -46,4 +48,5 @@
 		"    --mnc <mnc>:                    Mobile Network Code\n" \
 		"  --get-signal-info:                Get signal strength info\n" \
 		"  --get-serving-system:             Get serving system info\n" \
-
+		"  --get-cell-location-info:         Get cell location info\n" \
+		"  --get-tx-rx-info:                 Get tx and rx info\n"
diff -Naur a/data/qmi-service-nas.json b/data/qmi-service-nas.json
--- a/data/qmi-service-nas.json	2019-10-23 17:13:24.004931102 -0700
+++ b/data/qmi-service-nas.json	2019-10-23 17:27:12.960619419 -0700
@@ -3115,6 +3115,14 @@
                                        "public-format" : "gboolean" },
                                      { "name"   : "Tx Power",
                                        "format" : "gint32" } ],
+                     "prerequisites": [ { "common-ref" : "Success" } ] },
+                   { "name"      : "LTE Uplink Modulation",
+                     "id"        : "0x14",
+                     "mandatory" : "no",
+                     "type"      : "TLV",
+                     "format"    : "array",
+                     "array-element" : { "name"     : "Modulation",
+                                         "format"   : "guint32" },
                      "prerequisites": [ { "common-ref" : "Success" } ] } ] },
 
   // *********************************************************************************
